<?

require("mysql.php");

$osc_access_token = "b4a2ed17************************************************7fc88f88";

$ch = curl_init();
$post = array("access_token"=>$osc_access_token, "ipp"=>500); // , "returnTrack"=>1
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
curl_setopt($ch, CURLOPT_TIMEOUT, 120);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

$url = "https://openstreetcam.org/1.0/list/";
$errstr = false;
$sequences_found = 0;
$images_found = 0;
$total_items = 0;
$page = 1;
$sequence_ids = array();
while($url !== false){
	$post["page"] = $page++;
	echo "Page: {$post['page']}\r\n";
	$attempts = 4;
	$success = false;
	while(1){
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
		$response = curl_exec($ch);
		$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		if(!is_string($response)){
			if($attempts > 0){
				echo "Failed to contact OpenStreetCam server: ".curl_error($ch).", retrying...\r\n";
				$attempts--;
				sleep(3);
				continue;
			}else{
				$errstr = "Failed to contact OpenStreetCam server: ".curl_error($ch);
				break;
			}
		}else if($http_code != 200){
			if($attempts > 0){
				echo "OpenStreetCam server returned error {$http_code}, retrying...\r\n";
				$attempts--;
				sleep(3);
				continue;
			}else{
				$errstr = "OpenStreetCam server returned error {$http_code}";
				break;
			}
		}
		$success = true;
		break;
	}
	if(!$success){
		break; // all attempts failed
	}
	$data = json_decode($response, true);
	if(!is_array($data) || !isset($data["status"]) || !isset($data["currentPageItems"])){
		$errstr = "Invalid response from OpenStreetCam server";
		break;
	}
	//print_r($data);die();
	if(count($data["currentPageItems"]) == 0){
		break;
	}
	if(isset($data["totalFilteredItems"]) && isset($data["totalFilteredItems"][0])){
		$total_items = intval($data["totalFilteredItems"][0]);
	}

	$time = time();
	foreach($data["currentPageItems"] as $v){
		if(!isset($v["id"])){
			continue;
		}
		$sequence_id = $v["id"];
		$set = array();
		$set["user_id"] = $v["user_id"];
		$set["date_added"] = $v["date_added"];
		$set["platform_name"] = $v["platform_name"];
		$set["platform_version"] = $v["platform_version"];
		$set["status"] = $v["image_processing_status"];
		$set["images"] = $v["photo_no"];
		$set["nw_lat"] = $v["nw_lat"];
		$set["nw_lon"] = $v["nw_lng"];
		$set["se_lat"] = $v["se_lat"];
		$set["se_lon"] = $v["se_lng"];
		$set["distance"] = $v["distance"];
		$set["thumb_name"] = $v["thumb_name"];
		$set["updated"] = $time;
		mysql_query("insert into openstreetcam_sequence set sequence_id='".mysql_real_escape_string($sequence_id)."',".mysql_array_to_set($set)." on duplicate key update ".mysql_array_to_set($set)) or die(mysql_error());
		$sequences_found++;
		$images_found += intval($v["photo_no"]);
		$sequence_ids[$sequence_id] = $v["photo_no"];
	}
	if($total_items > 0 && $sequences_found == $total_items){
		echo "DONE\r\n";
		break;
	}
}

if($errstr !== false){
	echo "ERROR: {$errstr}\r\n";
}else{
	echo "seq:{$sequences_found},img:{$images_found}\r\n";
}

?>