<?

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
header("Cache-Control: no-store, no-cache, must-revalidate"); 
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require("mysql.php");
require("servers.php");

?>
<html>
<head>
<title>Job status</title>
<style>
body,table{
	font-family:Verdana;
	font-size:9px;
}
table{
	border-collapse:collapse;
}
td,th{
	text-align:left;
	border:1px solid #C0C0C0;
	padding:3px 6px;
}
tr.nbrd td{
	border:1px solid #FFF;
}
tr.bg1 td{
	background:#EEF6FF;
}
tr.bg2 td{
	background:#EEEEEE;
}
td.r,tr.bg1 td.r,tr.bg2 td.r{
	background:#FFCCCC;
}
td.gr,tr.bg1 td.gr,tr.bg2 td.gr{
	color:#CCC;
}
</style>
<script src="lib.js?v=<?=filemtime("lib.js");?>"></script>
</head>
<body>
<?

function htime($i, $short=false){
	$words = array("s", "seconds", "m", "minutes", "h", "hours", "d", "days");
	if($i<60){return $short?"$i {$words[0]}":"$i {$words[1]}";}
	$i=floor($i/60);
	if($i<60){return $short?"$i {$words[2]}":"$i {$words[3]}";}
	$i=floor($i/60);
	if($i<60){return $short?"$i {$words[4]}":"$i {$words[5]}";}
	$i=floor($i/24);
	return $short?"$i {$words[6]}":"$i {$words[7]}";
}

function ago($i, $short=false){
	if($i < 1){
		return $i;
	}
	return htime(time()-$i, $short)." ago";	
}

echo "<table border=1>";
echo "<tr><td>#</td><th>task_id</th><th>mapillary_userid</th><th>server</th><th>added</th><th>started</th><th>updated</th><th>finished</th><th>success</th>
<th>discovered</th>
<th>downloaded</th>
<th>uploaded</th>
<th>dw_speed</th>
<th>ul_speed</th>
<th>osc_sequence_id</th>
<th>errstr</th>
<th>avg</th>
</tr>";

$qr = mysql_query("select * from mp2osc_jobs where started>0 and (finished=0 or success=0) and (task='mp2osc' or task='osc2mp') order by mapillary_userid, started desc") or die(mysql_error());
$i = 0;
$dw_speed_sum = 0;
$ul_speed_sum = 0;
while($q = mysql_fetch_object($qr)){
	if($q->finished > 0 && $q->success < 1 && $q->finished < 1605283090){
		continue;
	}
	if($i % 6 == 2){
		echo "<tr class=bg1>";
	}else if($i % 6 == 5){
		echo "<tr class=bg2>";
	}else{
		echo "<tr>";
	}
	echo "<td>{$i}.</td>";
	echo "<td>{$q->task_id}</td>";
	//echo "<td><a href='https://osm.svimik.com/photosync/log.php?job={$q->task_id}&server_id={$q->server}' target='_blank'>log</a></td>";
	echo "<td>{$q->mapillary_userid}</td>";
	echo "<td".(isset($servers[$q->server]) ? "" : " class=gr").">{$q->server}</td>";
	echo "<td>".ago($q->added)."</td>";
	echo "<td>".ago($q->started)."</td>";
	echo "<td".(time()-$q->updated < 60 ? "" : " class=r").">".ago($q->updated)."</td>";
	echo "<td>".ago($q->finished)."</td>";
	echo "<td>{$q->success}</td>";
	if(substr($q->progress, 0, 1) == '{'){
		$p = json_decode($q->progress, true);
		//if($p['bytes_uploaded'] < 0){
		//	$p['bytes_uploaded']+=0xFFFFFFFF;
		//}
		echo "<td>{$p['images_discovered']}</td>";
		echo "<td>{$p['images_downloaded']}</td>";
		echo "<td>{$p['images_uploaded']}</td>";
		//echo "<td>".number_format($p['images_uploaded']/$p['images_discovered']*100, 0)."%</td>";
		echo "<td>".number_format($p['dw_speed']/1024/1024, 1)." MB/s</td>";
		echo "<td>".number_format($p['ul_speed']/1024/1024, 1)." MB/s</td>";
		echo "<td>{$p['osc_sequence_id']}</td>";
		echo "<td>{$p['errstr']}</td>";
		$dw_speed_sum += intval($p['dw_speed']);
		$ul_speed_sum += intval($p['ul_speed']);
		echo "<td>";
		if($p['bytes_uploaded'] > 0 && time() > $q->started){
			echo number_format(($p['bytes_uploaded']/(time()-$q->started))/1024/1024, 1)." MB/s";
		}else{
			echo "&nbsp;";
		}
		echo "</td>";
	}else if($q->progress != ""){
		echo "<td colspan=7>{$q->progress}</td>";
		echo "<td>&nbsp;</td>";
	}else{
		echo "<td colspan=7>&nbsp;</td>";
		echo "<td>&nbsp;</td>";
	}
	echo "</tr>";
	$i++;
}

echo "<tr class=nbrd>";
echo "<td colspan=12>&nbsp;</td>";
echo "<td>".number_format($dw_speed_sum/1024/1024, 1)." MB/s</td>";
echo "<td>".number_format($ul_speed_sum/1024/1024, 1)." MB/s</td>";
echo "<td colspan=3>&nbsp;</td>";
echo "</tr>";

echo "</table>";

?>
</body>
</html>