<html>
<head>
<title>Image transfer tool</title>
<style>
input{
	margin:4px 0;
}
</style>
</head>
<body>
<?

$redirect_url = "/photosync/";

session_set_cookie_params(365*24*60*60);
if(!session_start()){
	die("session_start() failed. That's a server error. Please contact the maintainer");
}

require("oauth_lib.php");

$settings["mapillary"]["conskey"] = "MkJKb*****************************************U5MzBh";

if(!empty($_POST["email"]) && !empty($_POST["password"])){
	$url = "https://a.mapillary.com/v2/ua/login?client_id=".$settings["mapillary"]["conskey"];
	$ch = curl_init();
	$post = array("email"=>$_POST["email"], "password"=>$_POST["password"]);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post));
	curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/x-www-form-urlencoded; charset=UTF-8"));
	//curl_setopt($ch, CURLOPT_HEADER, 1);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
	curl_setopt($ch, CURLOPT_TIMEOUT, 20);
	curl_setopt($ch, CURLOPT_URL, $url);
	$response = curl_exec($ch);
	$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if(!is_string($response)){
		$errstr = "Failed to contact Mapillary server: ".curl_error($ch);
		die($errstr);
	}else if($http_code != 200){
		$errstr = "Mapillary server returned error {$http_code}";
		if($http_code == 401){
			$errstr.="<br>\r\nCheck your login and password";
			$errstr.="<br>\r\n<a href=\"".basename(__FILE__)."\">Try again</a>";
		}
		die($errstr);
	}
	$data = json_decode($response, true);
	if(!is_array($data) || !isset($data["token"])){
		$errstr = "Error: invalid response from Mapillary server<br>{$response}";
		die($errstr);
	}
	$_GET["access_token"] = $data["token"];

	$ch = curl_init();

	$data = read_mapillary_profile($ch, $_GET["access_token"], $errstr);
	if($data === false){
		die($errstr);
	}
	foreach($data as $k=>$v){
		$_SESSION["mapillary_{$k}"] = $v;
	}
	$_SESSION["mapillary_access_token"] = $_GET["access_token"];
	$_SESSION["mapillary_client_id"] = $settings["mapillary"]["conskey"];

	header("Location: {$redirect_url}");
	echo "<a href=\"{$redirect_url}\">Continue</a>";
	die();
}

echo "Log in to Mapillary:<br>";
echo "<form action=\"\" method=post>";
echo "<input type=text name=email placeholder=\"Email address\"><br>";
echo "<input type=password name=password placeholder=\"Password\"><br>";
echo "<input type=submit value=\"Sign in\">";
echo "</form>";
echo "<s>(Yes, I know there's OAuth, but applications authenticated via OAuth don't have the access to unprocessed images)</s> They fixed it. You can use OAuth now if you like.<br>";
echo "The server <b>does not</b> store your password, but if you don't feel confident - change it before logging in, then you can change it back.<br>";

?>