<?

$redirect_url = "/photosync/";

//file_put_contents("oauth.log", print_r($_GET, true).print_r($_POST, true), FILE_APPEND);

session_set_cookie_params(365*24*60*60);
if(!session_start()){
	die("session_start() failed. That's a server error. Please contact the maintainer");
}

require("oauth_lib.php");

$settings["mapillary"]["conskey"] = "OWlkdE*****************************************4MjU3";

if(!isset($_GET["provider"])){
	die("invalid request");
}

if($_GET["provider"] == "osm"){
	if(!isset($_GET["oauth_token"])){
		die("Missing input parameter: oauth_token");
	}
	if(!isset($_SESSION["osm_oauth_token_secret"])){
		die("Missing session parameter: osm_oauth_token_secret");
	}

	$ch = curl_init();

	$verifier = "";
	if(isset($_GET["oauth_verifier"])){
		$verifier = $_GET["oauth_verifier"];
	}

	/* Obtain permanent OAuth key */
	$ret = oauth_access_token($ch, "osm", $_GET["oauth_token"], $_SESSION["osm_oauth_token_secret"], $verifier, $errstr);
	if($ret === false){
		die($errstr);
	}
	$_SESSION["osm_oauth_token"] = $ret["oauth_token"];
	$_SESSION["osm_oauth_token_secret"] = $ret["oauth_token_secret"];

	/* Read details */
	$xml = read_osm_profile($ch, $_SESSION["osm_oauth_token"], $_SESSION["osm_oauth_token_secret"], $errstr);
	if($xml === false){
		die($errstr);
	}
	$_SESSION["osm_id"] = intval($xml->user["id"]);
	$_SESSION["osm_display_name"] = strval($xml->user["display_name"]);
	//echo "OSM OK<br>";

	/* Try to log in into OpenStreetCam */
	$osc = openstreetcam_auth($ch, $_SESSION["osm_oauth_token"], $_SESSION["osm_oauth_token_secret"], $errstr);
	if($osc === false){
		die($errstr);
	}
	if(!empty($osc["osv"]["access_token"])){
		$_SESSION["openstreetcam"] = $_SESSION["osm_oauth_token"];
		$_SESSION["openstreetcam_userid"] = $osc["osv"]["id"];
		$_SESSION["openstreetcam_username"] = $osc["osv"]["username"];
		$_SESSION["openstreetcam_token"] = $osc["osv"]["access_token"];
	}

	header("Location: {$redirect_url}");
	echo "<a href=\"{$redirect_url}\">Continue</a>";
}else if($_GET["provider"] == "mapillary"){
	if(!isset($_GET["access_token"])){
		die("Missing input parameter: access_token");
	}

	$ch = curl_init();

	$data = read_mapillary_profile($ch, $_GET["access_token"], $errstr);
	if($data === false){
		die($errstr);
	}
	foreach($data as $k=>$v){
		$_SESSION["mapillary_{$k}"] = $v;
	}
	$_SESSION["mapillary_access_token"] = $_GET["access_token"];
	$_SESSION["mapillary_client_id"] = $settings["mapillary"]["conskey"];

	header("Location: {$redirect_url}");
	echo "<a href=\"{$redirect_url}\">Continue</a>";
}

?>